unit DnDListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellapi;

type
  TFileDropped = procedure (Sender : TObject; FileName : string; var accept : boolean) of object;
  TDnDListBox = class(TListBox)
  private
    { Dclarations prives }
    FFileDropped : TFileDropped;
    FLbAddString, FLbInsertString, FLbDeleteString : TNotifyEvent;
    FAutoAdd : boolean;
  protected
    { Dclarations protges }
    procedure WMDROPFILES(var msg : TMessage); message WM_DROPFILES;
    procedure LBADDSTRING(var msg : TMessage); message LB_ADDSTRING;
    procedure LBINSERTSTRING(var msg : TMessage); message LB_INSERTSTRING;
    procedure LBDELETESTRING(var msg : TMessage); message LB_DELETESTRING;
    procedure FileDropped(FileName : string); virtual;
  public
    { Dclarations publiques }
    constructor Create(AOwner : TComponent); override;
    procedure CreateWnd; override;
  published
    { Dclarations publies }
    property AutoAdd : boolean read FAutoAdd write FAutoAdd;
    property OnFileDropped : TFileDropped read FFileDropped write FFileDropped;
    property OnAddString : TNotifyEvent read FLbAddString write FLbAddString;
    property OnInsertString : TNotifyEvent read FLbInsertString write FLbInsertString;
    property OnDeleteString : TNotifyEvent read FLbDeleteString write FLbDeleteString;
  end;

procedure Register;

implementation

constructor TDnDListBox.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FAutoAdd:=true;
end;

procedure TDnDListBox.LBADDSTRING(var msg : TMessage);
begin
  if assigned(FLbAddString) then FLbAddString(self);
  inherited;
end;

procedure TDnDListBox.LBINSERTSTRING(var msg : TMessage);
begin
  if assigned(FLbInsertString) then FLbInsertString(self);
  inherited;
end;

procedure TDnDListBox.LBDELETESTRING(var msg : TMessage);
begin
  if assigned(FLbDeleteString) then FLbDeleteString(self);
  inherited;
end;

procedure TDnDListBox.FileDropped(FileName : string);
var acp : boolean;
begin
  acp:=true;
  if assigned(FFileDropped) then FFileDropped(self,FileName,acp);
  if (FAutoAdd and acp) then self.items.add(filename); 
end;

procedure TDnDListBox.WMDROPFILES(var msg : TMessage);
var
  dr : HDrop;
  nb, j : integer;
  fn : array[0..254] of char;
begin
  dr:=msg.wparam;
  nb:=DragQueryFile(dr,$FFFFFFFF,fn,sizeof(fn));
  for j:=0 to nb-1 do begin
    DragQueryFile(dr,j,fn,sizeof(fn));
    FileDropped(fn);
  end;
  DragFinish(dr);
//  inherited;
end;

procedure TDnDListBox.CreateWnd;
begin
  inherited;
  DragAcceptFiles(self.handle,true);
end;

procedure Register;
begin
  RegisterComponents('Steff', [TDnDListBox]);
end;

end.
